// C Source File
// Created 22-07-2004; 20:10:37

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 200           // Compile for AMS 2.00 or higher
#define SAVE_SCREEN           // Save/Restore LCD Contents
#define USE_DOUBLEBUFFERING
#define VERSION "1.0"
#include <tigcclib.h>         // Include All Header Files
#include "menulib.h"
#include "extgraph.h"
void *plan9;
void *plan1;

void POINT(int y, int x)
{
GraySetAMSPlane(LIGHT_PLANE);
DrawPix(x,y,A_NORMAL);
GraySetAMSPlane(DARK_PLANE);
DrawPix(x,y,A_NORMAL);
return;
}

void delay(void)
{
	short int loop = 13000, temp = 0;
	
	// count to slow the program down
	while (loop-- > 0) {
		temp++;
	}
	return;
}

void InputStr(char *buffer, unsigned short maxlen)
{
  SCR_STATE ss;
  short key;
  unsigned short i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer);
        // Note that two spaces are required only if the F_4x6 font is used
      key = ngetchx ();
      if (key >= ' ' && key <= '~' && i < maxlen)
        buffer[i++] = key;
      else if (key == KEY_BACKSPACE && i)
        i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER);
}

// Main Function
char cFilnavn[10];
FILE *fFil;
short sInput;

char *cpProg;
char *cpData;
unsigned short *spProgramPegePind;
unsigned short *spDataPegePind;


int Debugmode()
{
	int debugmode=0;
	char *pcMenuitems[3];
	char cMenuitemDebugmodeOn[16], cMenuitemDebugmodeOff[16];
	

	pcMenuitems[0]=cMenuitemDebugmodeOff;
	pcMenuitems[1]=cMenuitemDebugmodeOn;
	pcMenuitems[2]=NULL;
	sprintf(pcMenuitems[0], "%s", "Debugmode off");
	sprintf(pcMenuitems[1], "%s", "Debugmode on");
	ScrRectFill(&(SCR_RECT){{32, 29+(debugmode*12), 110-(debugmode*6), 40+(debugmode*12)}}, ScrRect, A_XOR);
	debugmode = menufunc(pcMenuitems, "Debugmode");
	clrscr();
	if (debugmode == 1)
		printf("Debugmode is on");
	else 
		printf("Debugmode is off");
	ngetchx();
	return debugmode;
}

int hentfil()
{
	if (fFil != NULL)
		fclose(fFil);
	printf("Enter filename: ");
	InputStr (cFilnavn, 10);
	fFil = fopen(cFilnavn,"rt");
	
	
	if (fFil == NULL)	
	{
		printf("You speell like shsit\n");
		getchar();
		return 1;
	}
	
	
	return 0;
}

int ASCIIresolv()
{
	char cInput[3];
	char cTemp;
	char *pcMenuitems[3]={"ASCII->char","Char->ASCII",(char*)0};
	
	clrscr();
	//printf("Tast et for ASCII->Tegn,\nto for Tegn->ASCII:\n");
	//cTemp = getchar();
	
	cTemp = menufunc(pcMenuitems,"ASCII-conv.");
	
	if (cTemp == 0)
	{
			printf("Enter nr.:\n");
			InputStr (cInput, 3);
			printf("%c\n", atoi(cInput));
			getchar();
			return 0;
			
	}
	else if (cTemp == 1)
	{
			printf("Enter char.:\n");
			cTemp = getchar();
			printf("\n%i\n",(int)cTemp);
			getchar();
			
	}
	
	return 0;
	
}

int interpreter(int debugmode)
{
	memset(cpProg, 0, 1000);
	memset(cpData, 0, 30000);
	memset(spProgramPegePind,-1,200);		//virker selvom short er to bytes
	memset(spDataPegePind,-1,200);			//--||---
	
	
	int iLevende = 1;
	if (fFil == NULL)	
	{
		printf("You must load a file\n");
		getchar();
		return 1;
	}
	fseek(fFil,0,SEEK_SET);
	

	sInput = fgetc(fFil);
	char *pPegePind = cpProg;
	for(;sInput != EOF && (pPegePind - cpProg) < 2000;
		((sInput == '<' || sInput == '>' || sInput == '[' || sInput == ']' || 
		sInput == '+' || sInput == '-' || sInput == ',' || sInput == '.' || 
		sInput == 'Y')?(*pPegePind = (char)sInput,pPegePind++):NULL),sInput = fgetc(fFil));
	*pPegePind = 0;

	
	
	void *kbq = kbd_queue ();
	unsigned short key;
	sInput = -1;
	spProgramPegePind[0]=0;
	spDataPegePind[0]=0;
	while(iLevende){
		iLevende = 0;
		if (!OSdequeue (&key, kbq))
		{
			if(key == KEY_ESC) goto end;
			if(sInput == -1)
				sInput = key;
		}
		int iTraadNR = 0;
		for (;iTraadNR < 100;iTraadNR++)
		{
			long int i,x;
			if (spProgramPegePind[iTraadNR] == 0xffff) continue;
			if (debugmode == 1)
			{
			putchar(cpProg[spProgramPegePind[iTraadNR]]);
			printf("%i\n",cpData[spDataPegePind[iTraadNR]]);
			for (x=0;x<1000000;x++)
				{
				i++;
				}
			}
			iLevende = 1;
			switch (cpProg[spProgramPegePind[iTraadNR]])
			{
				case '+':
					cpData[spDataPegePind[iTraadNR]]++;
					spProgramPegePind[iTraadNR]++;
					break;
				case '-':
					cpData[spDataPegePind[iTraadNR]]--;
					spProgramPegePind[iTraadNR]++;
					break;
				case '>':
					spDataPegePind[iTraadNR]++;
					spProgramPegePind[iTraadNR]++;
					if(spDataPegePind[iTraadNR]>29999)
							{
								printf("30k was not enough for you?!");
								getchar();
								goto end;	//AAAAAAAAAAaadddddddddd;
							}
					break;
				case '<':
					spDataPegePind[iTraadNR]--;
					spProgramPegePind[iTraadNR]++;
					if(spDataPegePind[iTraadNR]>29999)
							{
								printf("Imagine sinking so deep!");
								getchar();
								goto end;	//AAAAAAAAAAaadddddddddd;
							}
					break;
				case '.':
					putchar((short)cpData[spDataPegePind[iTraadNR]]);
					spProgramPegePind[iTraadNR]++;
					break;
				case ',':
					if (sInput != -1)
					{
						putchar(sInput);
						cpData[spDataPegePind[iTraadNR]]=(char)sInput;
						spProgramPegePind[iTraadNR]++;
						sInput = -1;
					}
					break;
				case '[':
					if (cpData[spDataPegePind[iTraadNR]])
					{
						spProgramPegePind[iTraadNR]++;
					}
					else
					{
						int iIlse=0;
						do
						{
							switch (cpProg[spProgramPegePind[iTraadNR]])
							{
								case '[':
									iIlse++;
									break;
								case ']':
									iIlse--;
									break;
							}
							spProgramPegePind[iTraadNR]++;
							if(spProgramPegePind[iTraadNR]>1998)
							{
								printf("You are so ugly!!");
								getchar();
								goto end;	//AAAAAAAAAAaadddddddddd;
							}
						}while(iIlse != 0);
					}						
					break;		
							
				case ']':
					{
					int iIrene=0;
					do
					{
						switch (cpProg[spProgramPegePind[iTraadNR]])
						{
							case '[':
								iIrene--;
								break;
							case ']':
								iIrene++;
								break;
						}
						spProgramPegePind[iTraadNR]--;
						if(spProgramPegePind[iTraadNR]>1998)
						{
							printf("Still ugly!!");
							getchar();
							goto end;	//AAAAAAAAAAaadddddddddd;
						}
					}while(iIrene != 0);
					spProgramPegePind[iTraadNR]++;
					}
					break;	
					
				case 'Y':
					{
						int iAndenTraadNR=0;
						while(spProgramPegePind[iAndenTraadNR]!=0xffff&&
							iAndenTraadNR<99)iAndenTraadNR++;
						if(spProgramPegePind[iAndenTraadNR]!=0xffff)
						{
							printf("Pervert!!");
							getchar();
							goto end;	//AAAAAAAAAAaadddddddddd;							
						}
						spProgramPegePind[iTraadNR]++;
						spProgramPegePind[iAndenTraadNR]=spProgramPegePind[iTraadNR];
						spDataPegePind[iAndenTraadNR]=spDataPegePind[iTraadNR]+1;
						if(spDataPegePind[iAndenTraadNR]>29999)
						{
							printf("30k was not enough!?");
							getchar();
							goto end;	//AAAAAAAAAAaadddddddddd;
						}
						cpData[spDataPegePind[iTraadNR]]=0;
						cpData[spDataPegePind[iAndenTraadNR]]=1;
						break;
					}
				
				case 0:
					spProgramPegePind[iTraadNR]=0xffff;
					spDataPegePind[iTraadNR]=0xffff;
					break;
				default:
					printf("Armaggedon draws closer!!\n(or cosmic ray out of bounds)");
					getchar();
					goto end;	//AAAAAAAAAAaadddddddddd;
					break;
			}
			
		}
	}
	getchar();
end:

	return 0;
}

void SpriteTegner(int x, int y)
{
	static unsigned long blyant[64] = {
    0x00001000,0x00002800,0x00004400,0x00008200,
    0x00010300,0x00020780,0x00040FC0,0x00081FE0,
    0x00103FF0,0x00207FF8,0x0040FFE4,0x0081FFC2,
    0x0103FF81,0x0207FF02,0x040FFE04,0x081FFC08,
    0x103FF810,0x207FF020,0x40FFE040,0x81FFC080,
    0xC3FF8100,0xA7FF0200,0x9FFE0400,0x8FFC0800,
    0x87F81000,0x83F02000,0x81E04000,0x80C08000,
    0xC0410000,0xE0220000,0xF0140000,0xFFF80000,
    0x00001000,0x00003800,0x00007C00,0x0000FE00,
    0x0001FF00,0x0003FC80,0x0007F840,0x000FF020,
    0x001FE010,0x003FC018,0x007F803C,0x00FF007E,
    0x01FE00FF,0x03FC01FE,0x07F803FC,0x0FF007F8,
    0x1FE00FF0,0x3FC01FE0,0x7F803FC0,0xFF007F80,
    0xFE00FF00,0xBC01FE00,0x9803FC00,0x8807F800,
    0x840FF000,0x821FE000,0x813FC000,0x80FF8000,
    0xC07F0000,0xE03E0000,0xF01C0000,0xFFF80000
  	};
	  unsigned long blyantmaske[32] = {
    0xFFFFEFFF,0xFFFFC7FF,0xFFFF83FF,0xFFFF01FF,
    0xFFFE00FF,0xFFFC007F,0xFFF8003F,0xFFF0001F,
    0xFFE0000F,0xFFC00007,0xFF800003,0xFF000001,
    0xFE000000,0xFC000001,0xF8000003,0xF0000007,
    0xE000000F,0xC000001F,0x8000003F,0x0000007F,
    0x000000FF,0x000001FF,0x000003FF,0x000007FF,
    0x00000FFF,0x00001FFF,0x00003FFF,0x00007FFF,
    0x0000FFFF,0x0001FFFF,0x0003FFFF,0x0007FFFF
  };
	  
	  
	  GrayClipSprite32_MASK_R(x,y-32,32,blyant,&blyant[32],blyantmaske,blyantmaske,GrayGetPlane (LIGHT_PLANE),GrayGetPlane (DARK_PLANE));
	  
	  
	  //Sprite32 (x,y,32,sprite,GrayGetPlane (DARK_PLANE),SPRT_XOR);
	  //Sprite32 (x,y,32, &sprite[32],GrayGetPlane (LIGHT_PLANE),SPRT_XOR);

  	
  	
}

void useVisionLine (long y1, long x1, long y2, long x2)
{
    
  
  long i;               // loop counter
  long ystep, xstep;    // the step on y and x axis
  long error;           // the error accumulated during the increment
  long errorprev;       // *vision the previous value of the error variable
  long y = y1, x = x1;  // the line points
  long ddy, ddx;        // compulsory variables: the double values of dy and dx
  long dx = x2 - x1;
  long dy = y2 - y1;
  POINT (y1, x1);  // first point
  // NB the last point can't be here, because of its previous point (which has to be verified)
  if (dy < 0){
    ystep = -1;
    dy = -dy;
  }else
    ystep = 1;
  if (dx < 0){
    xstep = -1;
    dx = -dx;
  }else
    xstep = 1;
  ddy = 2 * dy;  // work with double values for full precision
  ddx = 2 * dx;
  if (ddx >= ddy){  // first octant (0 <= slope <= 1)
    // compulsory initialization (even for errorprev, needed when dx==dy)
    errorprev = error = dx;  // start in the middle of the square
    for (i=0 ; i < dx ; i++){  // do not use the first point (already done)
      x += xstep;
      error += ddy;
      if (error > ddx){  // increment y if AFTER the middle ( > )
        y += ystep;
        error -= ddx;
        // three cases (octant == right->right-top for directions below):
        if (error + errorprev < ddx)  // bottom square also
          POINT (y-ystep, x);
        else if (error + errorprev > ddx)  // left square also
          POINT (y, x-xstep);
        else{  // corner: bottom and left squares also
          POINT (y-ystep, x);
          POINT (y, x-xstep);
        }
      }
  		POINT (y, x);
      memcpy(plan1, GrayGetPlane(LIGHT_PLANE), 3840);
      memcpy(plan9, GrayGetPlane(DARK_PLANE), 3840);
      SpriteTegner(x,y);
      delay();
      memcpy(GrayGetPlane(LIGHT_PLANE), plan1, 3840);
      memcpy(GrayGetPlane(DARK_PLANE), plan9, 3840);
      
      errorprev = error;
    }
  }else{  // the same as above
    errorprev = error = dy;
    for (i=0 ; i < dy ; i++){
      y += ystep;
      error += ddx;
      if (error > ddy){
        x += xstep;
        error -= ddy;
        if (error + errorprev < ddy)
          POINT (y, x-xstep);
        else if (error + errorprev > ddy)
          POINT (y-ystep, x);
        else{
          POINT (y, x-xstep);
          POINT (y-ystep, x);
        }
      }
      POINT (y, x);
      memcpy(plan1, GrayGetPlane(LIGHT_PLANE), 3840);
      memcpy(plan9, GrayGetPlane(DARK_PLANE), 3840);
      SpriteTegner(x,y);
      delay();
      memcpy(GrayGetPlane(LIGHT_PLANE), plan1, 3840);
      memcpy(GrayGetPlane(DARK_PLANE), plan9, 3840);
      
      errorprev = error;
    }
  }
  // assert ((y == y2) && (x == x2));  // the last point (y2,x2) has to be the same with the last point of the algorithm
}


void about(void)

{
	int i,y[10]={85,4,90,25,44,85},x[10]={41,80,90,30,124,41};
	plan1 = malloc(3840);
	plan9 = malloc(3840);
	
	if (plan1 == NULL || plan9 == NULL)
		{
			printf("Out of mem");
			ngetchx();
			return;
		}
	if (!GrayOn ()) return;
	
  ClrScr();


	for(i=0;i<5;i++)
		useVisionLine(y[i],x[i],y[i+1],x[i+1]);

	
	ngetchx();
  GrayOff ();
	
	free(plan1);
	free(plan9);
	clrscr();
	printf("Ti-89 Brainfork\ninterpreter v.%s\n\nBy Asger Ipsen\n    and\nPhilip Lventoft\n\nCheck bf.clanpogo.dk",VERSION);
	ngetchx();
  return;
}



void kasser (void)
{
	 int y1,x1,x2,y2;
	short Y1status =1, X1status = 1, Y2status = 1, X2status = 1; /* Hvis status = 0 er status faldende, hvis 1 er den stigende*/
  randomize();
  y1 = random(69);

  y2 = random(69);

  x1 = random(139);

  x2 = random(139);
  
  
  for(;;)
  {
  	// Frste rektangel
  if (X1status == 1 && Y1status == 1)
  		x1++,y1++;
  if (X1status == 1 && Y1status == 0)
  		x1++,y1--;
  if (X1status == 0 && Y1status == 1)
  		x1--,y1++;
  if (X1status == 0 && Y1status == 0)
  		x1--,y1--;
  if (x1 == 140)
  		X1status = 0;
  if (x1 == 0)
  		X1status = 1;
  if (y1 == 70)
  		Y1status = 0;
  if (y1 == 0)
  		Y1status = 1;
  		// Andet -||-
  if (X2status == 1 && Y2status == 1)
  		x2++,y2++;
  if (X2status == 1 && Y2status == 0)
  		x2++,y2--;
  if (X2status == 0 && Y2status == 1)
  		x2--,y2++;
  if (X2status == 0 && Y2status == 0)
  		x2--,y2--;
  if (x2 == 140)
  		X2status = 0;
  if (x2 == 0)
  		X2status = 1;
  if (y2 == 70)
  		Y2status = 0;
  if (y2 == 0)
  		Y2status = 1;
	if (kbhit())
	{
		ngetchx();
		return;
	}

		ScrRectFill (&(SCR_RECT){{x2,y2,x2+20,y2+20}}, ScrRect, A_NORMAL);
  	ScrRectFill (&(SCR_RECT){{x1,y1,x1+20,y1+20}}, ScrRect, A_NORMAL);

  DrawLine (0,90,160,90,A_NORMAL);
	delay();
  ClrScr ();

  }
  return;
}


void _main(void)
{

	cpProg = (char *)malloc(2000);
	cpData = (char *)malloc(30000);
	spProgramPegePind = (short *)malloc(200);
	spDataPegePind = (short *)malloc(200);
	
	
	if (cpProg  == NULL || cpData == NULL || spProgramPegePind==NULL || spDataPegePind==NULL)
	{
		printf("Out of mem");
		getchar();
		exit(1);
	}

	int debugmode=0;
	int i=0;
	
	char cMenuitemHentfil[20],
	cMenuitemASCIIresolv[30],cMenuitemHelp[20],
	cMenuitemExit[20],cMenuitemDebugmode[20],
	cMenuitemAbout[20],cMenuitemInterpreter[20];
	char *pcMenuitems[8]={cMenuitemHentfil,cMenuitemASCIIresolv,cMenuitemInterpreter,
	cMenuitemHelp,cMenuitemDebugmode,cMenuitemAbout,cMenuitemExit,NULL};
	sprintf(pcMenuitems[0], "%s", "Load file");
	sprintf(pcMenuitems[1], "%s", "ASCII resolv.");
	sprintf(pcMenuitems[2], "%s", "Run");
	sprintf(pcMenuitems[3], "%s", "Boxes");
	sprintf(pcMenuitems[4], "%s", "Debugmode");
	sprintf(pcMenuitems[5], "%s", "About");
	sprintf(pcMenuitems[6], "%s", "Exit");
	
	clrscr();
	printf("Welcome to *bf*\ninterpreter for TI-89\nv.%s\n\n",VERSION);
	printf("By Asger Ipsen og\nPhilip Lventoft");
	getchar();
	
	while(42)
	{
	clrscr();
	i = menufunc(pcMenuitems, "TIBF");
	switch (i)
		{
			case 0:
			{
				hentfil();
					
				break;
			}
			case 1:
			{
				ASCIIresolv();
				break;
			}
			case 2:
			{
					interpreter(debugmode);
								break;
			}
			case 3:
			{
			
			kasser();
				/*HANDLE textbuffer = HeapAlloc(200);
				memset (HeapDeref (textbuffer), 0, 200);
				if (textbuffer == H_NULL)
					{
					clrscr();
					printf("Out of memory");
					ngetchx();
					continue;
					}
					
				TE_open (&te, DeskTop, MakeWinRect (30, 30, 130, 70), textbuffer, 0, 0, 3);
			  CU_start ();
			  EV_captureEvents (EventHandler);
			  TRY
			    EV_eventLoop ();           // The only way to exit from "EV_eventLoop" is
			  ONERR                        //   to throw an error from the event handler
			    EV_captureEvents (NULL);
			  ENDTRY*/

				break;
			}
			case 4:
			{
				debugmode = Debugmode();
				break;
			}
			case 5:
			{
				about();
				break;
			}
			case 6:
			{
				goto end;
				break;
			}
			
			
		}
		
	}
	
end:	
	free(cpProg);
	free(cpData);
	free(spProgramPegePind);
	free(spDataPegePind);
	
return;
}

