/**********************************************************************************
This program is copyright by Asger Cronberg Ipsen and Philip Kaare Lventoft
(here after referred to as "the authors").
Released under the GNU General Public License.

Disclaimer:
By compiling, using or just reading this code you agree to the following:
By no means can the authors be held responsible for, including but not
limited to: any physical damage inflicted by the program, any data lost,
any other problems.

WARNING: This software is not in any way ready for public consumption and
you should only proceed using it, provided that you are ready for the
problems that will follow.

Please give us feedback at: (zxmaster@ofir.dk) (asger@v-data.dk).
**********************************************************************************/
#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 205           // Compile for AMS 2.05 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files


int Headlinecenter(char *title)
{
return (80-((strlen(title)*6)/2)); //returns the 
}

int menufunc(char *items[], char *title)
{
	/* How the stuff works...
	It takes an array of pointers to some character arrays as first argument. 
	Second argument is the title displayed in the top.
	Then it draws a menu and handles selecting and when enter is pressed 
	it returns the selection. Nice and clean. 
	Note: The argument array must be terminated with a NULL pointer.	*/
	
	int CurSel=0;		// The current selection
	int key=0;
	int printcount=0;	//Counts how long we are in the process of printing items.
	int charcount;		//Counts number of characters in current selection.
	int elements=0;
	int scrollcount=0;
	FontSetSys (F_6x8); 	//Makes sure that the font-size is 6*8...
	
	
	for (elements=0;items[elements]!=NULL;elements++);
	

	
		for (;;)
		{
			clrscr();
									// First thing to do is clearing the screen...
			static WIN_RECT rect = {30, 10, 130, 92};
			DrawClipRect (&rect, ScrRect, A_NORMAL); 	//Draws the surrounding rectangle

			static WIN_RECT line = {30, 22, 130, 22};
			DrawClipLine (&line, ScrRect, A_NORMAL); 	//Draws the line in the top

			DrawStr (Headlinecenter(title), 13, title, A_NORMAL); 		// Writes menu in the top
			

			for (printcount=0;printcount<5;printcount++)
				{
				if (items[printcount+scrollcount]==NULL)		
					break;
				DrawStr (34, 31+(printcount*12), items[printcount+scrollcount], A_NORMAL); 	//Now we are going to print the 5 items...
				}
			
			
			charcount = strlen(items[CurSel]);
			charcount++;
			
			WIN_RECT selbox = {32, 29+((CurSel-scrollcount)*12), 32+(charcount*6), 40+((CurSel-scrollcount)*12)};
			DrawClipRect (&selbox, ScrRect, A_NORMAL);
			
			
			key = ngetchx();

				switch (key)
				{
					case KEY_UP:
						{
	
						if (CurSel == 0)
						{
							CurSel = elements-1;
							if (elements > 5)
								scrollcount = elements-5;
						}
						else
							{
							if (scrollcount == CurSel)
								scrollcount--;
							CurSel--;
							}
						break;
						}
					case KEY_DOWN:
						{
						if (CurSel == elements-1)
							{	
							if (elements > 5)
								scrollcount = 0;
							CurSel = 0;
							}
						else
						{
						if (CurSel == scrollcount+4)
							scrollcount++;
						CurSel++;
						}
						break;
						}
					
					case 13://Key enter
						{
						clrscr();
						return CurSel;
						break;
						}
				}
		}
	
	return -1; // Returns -1 if something really weird happens. Start getting suspicious and look over your shoulder if you get this...	
}
